Subject: Re: bug#38618: 27.0.50; Mach port leak on macOS Catalina causing crash

From: YAMAMOTO Mitsuharu <[email-masked]>
Date: Tue, 17 Dec 2019 12:49:07 +0900

On Sun, 15 Dec 2019 10:35:10 +0900,
Phillip Hutchings wrote:
> 
> On macOS Catalina (all versions up to and including 10.15.2), after
> opening a file stored on an iCloud Drive folder Emacs leaks Mach ports
> eventually resulting in an Emacs crash during a random syscall.
> 
> Reproduction:
> * Using Emacs for MacOS X (currently using Nightly build, but also on
> the 26.3 release from 2019-09-02
> * Open a file stored in an iCloud Drive folder, eg Documents when using
> default settings
> * Modify the file, no need to save it, only modify the contents
> * Emacs will leak Mach ports on every edit.
> 
> This does not happen on non-iCloud Drive files, the port count observed 
> in Activity Monitor does not change for these files.

The Mac port (not the NS port in your report) also has the problem of
Mach port leaks in -[NSWindow setRepresentedURL:] on macOS 10.15.  I
think this is a bug in AppKit or some lower-level stuff.  I'll file it
to Apple later.

I've installed a workaround into the "work" branch of the repository
of the Mac port:

  https://bitbucket.org/mituharu/emacs-mac/commits/19c97087065b7ca64b71f392a453673042e024c6

				     YAMAMOTO Mitsuharu
				[email-masked]